---
- hosts: proxy:!default
  pre_tasks:
    - name: Include deploy variables.
      include_vars: 
        file: deploy_app.yml
      tags: [deploy_vars, setup]

    - name: Ensure nginx configuration directories exists
      file:
        path: '{{ item }}'
        state: directory
      loop:
        - '{{ nginx_config_main_template.conf_file_location }}/sites-enabled'
        - '{{ nginx_config_main_template.conf_file_location }}/sites-available'
      tags: [setup, proxy]

    - name: Ensure letsencrypt installed
      apt:
        name: letsencrypt
        state: present
        update_cache: yes
      tags: [setup, proxy, letsencrypt]

    - name: Ensure acme challange directories exists
      file:
        path: '{{ letsencrypt.acme_challenge_path }}'
        state: directory
        recurse: yes
      tags: [setup, proxy, letsencrypt]

  roles:
    - role: nginx
      tags: [setup, proxy, nginx]
    - role: nginx-config
      tags: [setup, proxy, nginx-config]

  post_tasks:
    - name: Apply nginx letsencrypt configuration.
      file:
        src: '{{ item.deployment_location }}'
        dest: '{{ nginx_config_main_template.conf_file_location }}/sites-enabled/{{ item.file_name }}'
        state: link
      when: "'letsencrypt' in item.labels"
      loop: '{{ nginx_config_http_template }}'
      notify: (Handler - NGINX Config) Start/reload NGINX
      tags: [setup, proxy, letsencrypt]

    - name: Force run handlers.
      meta: flush_handlers
      tags: [setup, proxy]
      
    - name: Create letsencrypt certificate
      shell: 'letsencrypt certonly -n --webroot -w {{ letsencrypt.acme_challenge_path }} -m {{ letsencrypt.email }} --agree-tos -d {{ item }}'
      args:
        creates: '{{ letsencrypt.certs_path }}/{{ item }}'
      loop: '{{ app_dns_records }}'
      tags: [setup, proxy, letsencrypt]
      

    - name: Apply nginx application configuration.
      file:
        src: '{{ item.deployment_location }}'
        dest: '{{ nginx_config_main_template.conf_file_location }}/sites-enabled/{{ item.file_name }}'
        state: link
      when: "'app' in item.labels"
      loop: '{{ nginx_config_http_template }}'
      notify: (Handler - NGINX Config) Start/reload NGINX
      tags: [setup, proxy]

...